#include <Carbon.h>
#include "altypes.h"
#include "alctypes.h"
#include "CFM_al_typedef.h"
#include "CFM_alc_typedef.h"
#include "CFM_alu_typedef.h"
#include "CFM_alut_typedef.h"
#include "CFM_Bridge.h"

CFBundleRef gBundleRefOpenAL = NULL;


// ==========================

// Specific missing entry point support code

OSStatus InitMissingOpenALEntryPoints (void);
void DeallocMissingOpenALEntryPoints (void);

// function pointer declarations
// Note: One could use the exact entry point names but it would have mulitply defined symbols in Mac OS X 10.2 and later
//       pfXXX is chosen to represent 'pointer to function'

// al.h
alEnablePtr pfalEnable = NULL;
alDisablePtr pfalDisable = NULL;
alIsEnabledPtr pfalIsEnabled = NULL;
alHintPtr pfalHint = NULL;
alGetBooleanPtr pfalGetBoolean = NULL;
alGetIntegerPtr pfalGetInteger = NULL;
alGetFloatPtr pfalGetFloat = NULL;
alGetDoublePtr pfalGetDouble = NULL;
alGetBooleanvPtr pfalGetBooleanv = NULL;
alGetIntegervPtr pfalGetIntegerv = NULL;
alGetFloatvPtr pfalGetFloatv = NULL;
alGetDoublevPtr pfalGetDoublev = NULL;
alGetStringPtr pfalGetString = NULL;
alGetErrorPtr pfalGetError = NULL;
alIsExtensionPresentPtr pfalIsExtensionPresent = NULL;
alGetProcAddressPtr pfalGetProcAddress = NULL;
alGetEnumValuePtr pfalGetEnumValue = NULL;
alListeneriPtr pfalListeneri = NULL;
alListenerfPtr pfalListenerf = NULL;
alListener3fPtr pfalListener3f = NULL; 
alListenerfvPtr pfalListenerfv = NULL; 
alGetListeneriPtr pfalGetListeneri = NULL;
alGetListenerfPtr pfalGetListenerf = NULL;
alGetListener3fPtr pfalGetListener3f = NULL; 
alGetListenerfvPtr pfalGetListenerfv = NULL; 
alGenSourcesPtr pfalGenSources = NULL; 
alDeleteSourcesPtr pfalDeleteSources = NULL;
alIsSourcePtr pfalIsSource = NULL; 
alSourceiPtr pfalSourcei = NULL;
alSourcefPtr pfalSourcef = NULL; 
alSource3fPtr pfalSource3f = NULL;
alSourcefvPtr pfalSourcefv = NULL; 
alGetSourceiPtr pfalGetSourcei = NULL;
alGetSourcefPtr pfalGetSourcef = NULL;
alGetSourcefvPtr pfalGetSourcefv = NULL;
alSourcePlayvPtr pfalSourcePlayv = NULL;
alSourceStopvPtr pfalSourceStopv = NULL;
alSourcePlayPtr pfalSourcePlay = NULL;
alSourcePausePtr pfalSourcePause = NULL;
alSourceStopPtr pfalSourceStop = NULL;
alGenBuffersPtr pfalGenBuffers = NULL;
alDeleteBuffersPtr pfalDeleteBuffers = NULL;
alIsBufferPtr pfalIsBuffer = NULL;
alBufferDataPtr pfalBufferData = NULL;
alGetBufferiPtr pfalGetBufferi = NULL;
alGetBufferfPtr pfalGetBufferf = NULL;
alSourceQueueBuffersPtr pfalSourceQueueBuffers = NULL;
alSourceUnqueueBuffersPtr pfalSourceUnqueueBuffers = NULL;
alDistanceModelPtr pfalDistanceModel = NULL;
alDopplerFactorPtr pfalDopplerFactor = NULL;
alDopplerVelocityPtr pfalDopplerVelocity = NULL;

// alc.h
alcGetStringPtr pfalcGetString = NULL;
alcGetIntegervPtr pfalcGetIntegerv = NULL;
alcOpenDevicePtr pfalcOpenDevice = NULL;
alcCloseDevicePtr pfalcCloseDevice = NULL;
alcCreateContextPtr pfalcCreateContext = NULL;
alcMakeContextCurrentPtr pfalcMakeContextCurrent = NULL;
alcProcessContextPtr pfalcProcessContext = NULL;
alcGetCurrentContextPtr pfalcGetCurrentContext = NULL;
alcGetContextsDevicePtr pfalcGetContextsDevice = NULL;
alcSuspendContextPtr pfalcSuspendContext = NULL;
alcDestroyContextPtr pfalcDestroyContext = NULL;
alcGetErrorPtr pfalcGetError = NULL;
alcIsExtensionPresentPtr pfalcIsExtensionPresent = NULL;
alcGetProcAddressPtr pfalcGetProcAddress = NULL;
alcGetEnumValuePtr pfalcGetEnumValue = NULL;

// alu.h
aluF2LPtr pfaluF2L = NULL;
aluF2SPtr pfaluF2S = NULL;
aluCrossproductPtr pfaluCrossproduct = NULL;
aluDotproductPtr pfaluDotproduct = NULL;
aluNormalizePtr pfaluNormalize = NULL;
aluMatrixVectorPtr pfaluMatrixVector = NULL;
aluCalculateSourceParametersPtr pfaluCalculateSourceParameters = NULL;
aluMixDataPtr pfaluMixData = NULL;
aluSetReverbPtr pfaluSetReverb = NULL;
aluReverbPtr pfaluReverb = NULL;

// alut.h
alutInitPtr pfalutInit = NULL;
alutExitPtr pfalutExit = NULL;
alutLoadWAVFilePtr pfalutLoadWAVFile = NULL;
alutLoadWAVMemoryPtr pfalutLoadWAVMemory = NULL;
alutUnloadWAVPtr pfalutUnloadWAV = NULL;
alutGetMajorVersionPtr pfalutGetMajorVersion = NULL;
alutGetMinorVersionPtr pfalutGetMinorVersion = NULL;

	
// ==========================

OSStatus InitMissingOpenALEntryPoints (void)
{
	OSStatus err = initEntryPoints (CFSTR("OpenAL.framework"), &gBundleRefOpenAL);	// init bundle
	if (noErr == err) {
		pfalEnable = (alEnablePtr) getProcAddress(CFSTR("alEnable"), &gBundleRefOpenAL);
		pfalDisable = (alDisablePtr) getProcAddress(CFSTR("alDisable"), &gBundleRefOpenAL);
		pfalIsEnabled = (alIsEnabledPtr) getProcAddress(CFSTR("alIsEnabled"), &gBundleRefOpenAL);
		pfalHint = (alHintPtr) getProcAddress(CFSTR("alHint"), &gBundleRefOpenAL);
		pfalGetBoolean = (alGetBooleanPtr) getProcAddress(CFSTR("alGetBoolean"), &gBundleRefOpenAL);
		pfalGetInteger = (alGetIntegerPtr) getProcAddress(CFSTR("alGetInteger"), &gBundleRefOpenAL);
		pfalGetFloat = (alGetFloatPtr) getProcAddress(CFSTR("alGetFloat"), &gBundleRefOpenAL);
		pfalGetDouble = (alGetDoublePtr) getProcAddress(CFSTR("alGetDouble"), &gBundleRefOpenAL);
		pfalGetBooleanv = (alGetBooleanvPtr) getProcAddress(CFSTR("alGetBooleanv"), &gBundleRefOpenAL);
		pfalGetIntegerv = (alGetIntegervPtr) getProcAddress(CFSTR("alGetIntegerv"), &gBundleRefOpenAL);
		pfalGetFloatv = (alGetFloatvPtr) getProcAddress(CFSTR("alGetFloatv"), &gBundleRefOpenAL);
		pfalGetDoublev = (alGetDoublevPtr) getProcAddress(CFSTR("alGetDoublev"), &gBundleRefOpenAL);
		pfalGetString = (alGetStringPtr) getProcAddress(CFSTR("alGetString"), &gBundleRefOpenAL);
		pfalGetError = (alGetErrorPtr) getProcAddress(CFSTR("alGetError"), &gBundleRefOpenAL);
		pfalIsExtensionPresent = (alIsExtensionPresentPtr) getProcAddress(CFSTR("alIsExtensionPresent"), &gBundleRefOpenAL);
		pfalGetProcAddress = (alGetProcAddressPtr) getProcAddress(CFSTR("alGetProcAddress"), &gBundleRefOpenAL);
		pfalGetEnumValue = (alGetEnumValuePtr) getProcAddress(CFSTR("alGetEnumValue"), &gBundleRefOpenAL);
		pfalListeneri = (alListeneriPtr) getProcAddress(CFSTR("alListeneri"), &gBundleRefOpenAL);
		pfalListenerf = (alListenerfPtr) getProcAddress(CFSTR("alListenerf"), &gBundleRefOpenAL);
		pfalListener3f = (alListener3fPtr) getProcAddress(CFSTR("alListener3f"), &gBundleRefOpenAL); 
		pfalListenerfv = (alListenerfvPtr) getProcAddress(CFSTR("alListenerfv"), &gBundleRefOpenAL); 
		pfalGetListeneri = (alGetListeneriPtr) getProcAddress(CFSTR("alGetListeneri"), &gBundleRefOpenAL);
		pfalGetListenerf = (alGetListenerfPtr) getProcAddress(CFSTR("alGetListenerf"), &gBundleRefOpenAL);
		pfalGetListener3f = (alGetListener3fPtr) getProcAddress(CFSTR("alGetListener3f"), &gBundleRefOpenAL); 
		pfalGetListenerfv = (alGetListenerfvPtr) getProcAddress(CFSTR("alGetListenerfv"), &gBundleRefOpenAL); 
		pfalGenSources = (alGenSourcesPtr) getProcAddress(CFSTR("alGenSources"), &gBundleRefOpenAL); 
		pfalDeleteSources = (alDeleteSourcesPtr) getProcAddress(CFSTR("alDeleteSources"), &gBundleRefOpenAL);
		pfalIsSource =  (alIsSourcePtr) getProcAddress(CFSTR("alIsSource"), &gBundleRefOpenAL); 
		pfalSourcei = (alSourceiPtr) getProcAddress(CFSTR("alSourcei"), &gBundleRefOpenAL);
		pfalSourcef = (alSourcefPtr) getProcAddress(CFSTR("alSourcef"), &gBundleRefOpenAL); 
		pfalSource3f = (alSource3fPtr) getProcAddress(CFSTR("alSource3f"), &gBundleRefOpenAL);
		pfalSourcefv = (alSourcefvPtr) getProcAddress(CFSTR("alSourcefv"), &gBundleRefOpenAL); 
		pfalGetSourcei = (alGetSourceiPtr) getProcAddress(CFSTR("alGetSourcei"), &gBundleRefOpenAL);
		pfalGetSourcef = (alGetSourcefPtr) getProcAddress(CFSTR("alGetSourcef"), &gBundleRefOpenAL);
		pfalGetSourcefv = (alGetSourcefvPtr) getProcAddress(CFSTR("alGetSourcefv"), &gBundleRefOpenAL);
		pfalSourcePlayv = (alSourcePlayvPtr) getProcAddress(CFSTR("alSourcePlayv"), &gBundleRefOpenAL);
		pfalSourceStopv = (alSourceStopvPtr) getProcAddress(CFSTR("alSourceStopv"), &gBundleRefOpenAL);
		pfalSourcePlay = (alSourcePlayPtr) getProcAddress(CFSTR("alSourcePlay"), &gBundleRefOpenAL);
		pfalSourcePause = (alSourcePausePtr) getProcAddress(CFSTR("alSourcePause"), &gBundleRefOpenAL);
		pfalSourceStop = (alSourceStopPtr) getProcAddress(CFSTR("alSourceStop"), &gBundleRefOpenAL);
		pfalGenBuffers = (alGenBuffersPtr) getProcAddress(CFSTR("alGenBuffers"), &gBundleRefOpenAL);
		pfalDeleteBuffers = (alDeleteBuffersPtr) getProcAddress(CFSTR("alDeleteBuffers"), &gBundleRefOpenAL);
		pfalIsBuffer = (alIsBufferPtr) getProcAddress(CFSTR("alIsBuffer"), &gBundleRefOpenAL);
		pfalBufferData = (alBufferDataPtr) getProcAddress(CFSTR("alBufferData"), &gBundleRefOpenAL);
		pfalGetBufferi = (alGetBufferiPtr) getProcAddress(CFSTR("alGetBufferi"), &gBundleRefOpenAL);
		pfalGetBufferf = (alGetBufferfPtr) getProcAddress(CFSTR("alGetBufferf"), &gBundleRefOpenAL);
		pfalSourceQueueBuffers = (alSourceQueueBuffersPtr) getProcAddress(CFSTR("alSourceQueueBuffers"), &gBundleRefOpenAL);
		pfalSourceUnqueueBuffers = (alSourceUnqueueBuffersPtr) getProcAddress(CFSTR("alSourceUnqueueBuffers"), &gBundleRefOpenAL);
		pfalDistanceModel = (alDistanceModelPtr) getProcAddress(CFSTR("alDistanceModel"), &gBundleRefOpenAL);
		pfalDopplerFactor = (alDopplerFactorPtr) getProcAddress(CFSTR("alDopplerFactor"), &gBundleRefOpenAL);
		pfalDopplerVelocity = (alDopplerVelocityPtr) getProcAddress(CFSTR("alDopplerVelocity"), &gBundleRefOpenAL);

		pfalcGetString = (alcGetStringPtr) getProcAddress(CFSTR("alcGetString"), &gBundleRefOpenAL);
		pfalcGetIntegerv = (alcGetIntegervPtr) getProcAddress(CFSTR("alcGetIntegerv"), &gBundleRefOpenAL);
		pfalcOpenDevice = (alcOpenDevicePtr) getProcAddress(CFSTR("alcOpenDevice"), &gBundleRefOpenAL);
		pfalcCloseDevice = (alcCloseDevicePtr) getProcAddress(CFSTR("alcCloseDevice"), &gBundleRefOpenAL);
		pfalcCreateContext = (alcCreateContextPtr) getProcAddress(CFSTR("alcCreateContext"), &gBundleRefOpenAL);
		pfalcMakeContextCurrent = (alcMakeContextCurrentPtr) getProcAddress(CFSTR("alcMakeContextCurrent"), &gBundleRefOpenAL);
		pfalcProcessContext = (alcProcessContextPtr) getProcAddress(CFSTR("alcProcessContext"), &gBundleRefOpenAL);
		pfalcGetCurrentContext = (alcGetCurrentContextPtr) getProcAddress(CFSTR("alcGetCurrentContext"), &gBundleRefOpenAL);
		pfalcGetContextsDevice = (alcGetContextsDevicePtr) getProcAddress(CFSTR("alcGetContextsDevice"), &gBundleRefOpenAL);
		pfalcSuspendContext = (alcSuspendContextPtr) getProcAddress(CFSTR("alcSuspendContext"), &gBundleRefOpenAL);
		pfalcDestroyContext = (alcDestroyContextPtr) getProcAddress(CFSTR("alcDestroyContext"), &gBundleRefOpenAL);
		pfalcGetError = (alcGetErrorPtr) getProcAddress(CFSTR("alcGetError"), &gBundleRefOpenAL);
		pfalcIsExtensionPresent = (alcIsExtensionPresentPtr) getProcAddress(CFSTR("alcIsExtensionPresent"), &gBundleRefOpenAL);
		pfalcGetProcAddress = (alcGetProcAddressPtr) getProcAddress(CFSTR("alcGetProcAddress"), &gBundleRefOpenAL);
		pfalcGetEnumValue = (alcGetEnumValuePtr) getProcAddress(CFSTR("alcGetEnumValue"), &gBundleRefOpenAL);

		pfaluF2L = (aluF2LPtr) getProcAddress(CFSTR("aluF2L"), &gBundleRefOpenAL);
		pfaluF2S = (aluF2SPtr) getProcAddress(CFSTR("aluF2S"), &gBundleRefOpenAL);
		pfaluCrossproduct = (aluCrossproductPtr) getProcAddress(CFSTR("aluCrossproduct"), &gBundleRefOpenAL);
		pfaluDotproduct = (aluDotproductPtr) getProcAddress(CFSTR("aluDotproduct"), &gBundleRefOpenAL);
		pfaluNormalize = (aluNormalizePtr) getProcAddress(CFSTR("aluNormalize"), &gBundleRefOpenAL);
		pfaluMatrixVector = (aluMatrixVectorPtr) getProcAddress(CFSTR("aluMatrixVector"), &gBundleRefOpenAL);
		pfaluCalculateSourceParameters = (aluCalculateSourceParametersPtr) getProcAddress(CFSTR("aluCalculateSourceParameters"), &gBundleRefOpenAL);
		pfaluMixData = (aluMixDataPtr) getProcAddress(CFSTR("aluMixData"), &gBundleRefOpenAL);
		pfaluSetReverb = (aluSetReverbPtr) getProcAddress(CFSTR("aluSetReverb"), &gBundleRefOpenAL);
		pfaluReverb = (aluReverbPtr) getProcAddress(CFSTR("aluReverb"), &gBundleRefOpenAL);

		pfalutInit = (alutInitPtr) getProcAddress(CFSTR("alutInit"), &gBundleRefOpenAL);
		pfalutExit = (alutExitPtr) getProcAddress(CFSTR("alutExit"), &gBundleRefOpenAL);
		pfalutLoadWAVFile = (alutLoadWAVFilePtr) getProcAddress(CFSTR("alutLoadWAVFile"), &gBundleRefOpenAL);
		pfalutLoadWAVMemory = (alutLoadWAVMemoryPtr) getProcAddress(CFSTR("alutLoadWAVMemory"), &gBundleRefOpenAL);
		pfalutUnloadWAV = (alutUnloadWAVPtr) getProcAddress(CFSTR("alutUnloadWAV"), &gBundleRefOpenAL);
		pfalutGetMajorVersion = (alutGetMajorVersionPtr) getProcAddress(CFSTR("alutGetMajorVersion"), &gBundleRefOpenAL);
		pfalutGetMinorVersion = (alutGetMinorVersionPtr) getProcAddress(CFSTR("alutGetMinorVersion"), &gBundleRefOpenAL);
 	}
	return err;
}

// -------------------------

void DeallocMissingOpenALEntryPoints (void)
{
	pfalEnable = NULL;
	pfalDisable = NULL;
	pfalIsEnabled = NULL;
	pfalHint = NULL;
	pfalGetBoolean = NULL;
	pfalGetInteger = NULL;
	pfalGetFloat = NULL;
	pfalGetDouble = NULL;
	pfalGetBooleanv = NULL;
	pfalGetIntegerv = NULL;
	pfalGetFloatv = NULL;
	pfalGetDoublev = NULL;
	pfalGetString = NULL;
	pfalGetError = NULL;
	pfalIsExtensionPresent = NULL;
	pfalGetProcAddress = NULL;
	pfalGetEnumValue = NULL;
	pfalListeneri = NULL;
	pfalListenerf = NULL;
	pfalListener3f = NULL; 
	pfalListenerfv = NULL; 
	pfalGetListeneri = NULL;
	pfalGetListenerf = NULL;
	pfalGetListener3f = NULL; 
	pfalGetListenerfv = NULL; 
	pfalGenSources = NULL; 
	pfalDeleteSources = NULL;
	pfalIsSource = NULL; 
	pfalSourcei = NULL;
	pfalSourcef = NULL; 
	pfalSource3f = NULL;
	pfalSourcefv = NULL; 
	pfalGetSourcei = NULL;
	pfalGetSourcef = NULL;
	pfalGetSourcefv = NULL;
	pfalSourcePlayv = NULL;
	pfalSourceStopv = NULL;
	pfalSourcePlay = NULL;
	pfalSourcePause = NULL;
	pfalSourceStop = NULL;
	pfalGenBuffers = NULL;
	pfalDeleteBuffers = NULL;
	pfalIsBuffer = NULL;
	pfalBufferData = NULL;
	pfalGetBufferi = NULL;
	pfalGetBufferf = NULL;
	pfalSourceQueueBuffers = NULL;
	pfalSourceUnqueueBuffers = NULL;
	pfalDistanceModel = NULL;
	pfalDopplerFactor = NULL;
	pfalDopplerVelocity = NULL;
	
	pfalcGetString = NULL;
	pfalcGetIntegerv = NULL;
	pfalcOpenDevice = NULL;
	pfalcCloseDevice = NULL;
	pfalcCreateContext = NULL;
	pfalcMakeContextCurrent = NULL;
	pfalcProcessContext = NULL;
	pfalcGetCurrentContext = NULL;
	pfalcGetContextsDevice = NULL;
	pfalcSuspendContext = NULL;
	pfalcDestroyContext = NULL;
	pfalcGetError = NULL;
	pfalcIsExtensionPresent = NULL;
	pfalcGetProcAddress = NULL;
	pfalcGetEnumValue = NULL;

	pfaluF2L = NULL;
	pfaluF2S = NULL;
	pfaluCrossproduct = NULL;
	pfaluDotproduct = NULL;
	pfaluNormalize = NULL;
	pfaluMatrixVector = NULL;
	pfaluCalculateSourceParameters = NULL;
	pfaluMixData = NULL;
	pfaluSetReverb = NULL;
	pfaluReverb = NULL;

	pfalutInit = NULL;
	pfalutExit = NULL;
	pfalutLoadWAVFile = NULL;
	pfalutLoadWAVMemory = NULL;
	pfalutUnloadWAV = NULL;
	pfalutGetMajorVersion = NULL;
	pfalutGetMinorVersion = NULL;

	deallocEntryPoints (&gBundleRefOpenAL); // dump bundle
}
