#ifndef _CFM_ALC_H_
#define _CFM_ALC_H_

typedef struct ALCdevice_struct ALCdevice;
typedef struct ALCcontext_struct ALCcontext;


#ifdef __cplusplus
extern "C" {
#endif

typedef ALCubyte*  (*alcGetStringPtr)( ALCdevice *device, ALCenum param );
typedef ALCvoid    (*alcGetIntegervPtr)( ALCdevice * device, ALCenum param, ALCsizei size, ALCint *data );
typedef ALCdevice* (*alcOpenDevicePtr)( ALubyte *deviceName );
typedef ALCvoid    (*alcCloseDevicePtr)( ALCdevice *device );
typedef ALCcontext*(*alcCreateContextPtr)( ALCdevice *device,ALCint *attrList );
typedef ALCboolean (*alcMakeContextCurrentPtr)( ALCcontext *context );
typedef ALCvoid	   (*alcProcessContextPtr)( ALCcontext *context );
typedef ALCcontext*(*alcGetCurrentContextPtr)( ALCvoid );
typedef ALCdevice* (*alcGetContextsDevicePtr)( ALCcontext *context );
typedef ALCvoid	   (*alcSuspendContextPtr)( ALCcontext *context );
typedef ALCvoid    (*alcDestroyContextPtr)( ALCcontext *context );
typedef ALCenum	   (*alcGetErrorPtr)( ALCdevice *device );
typedef ALCboolean (*alcIsExtensionPresentPtr)( ALCdevice *device,ALCubyte *extName );
typedef ALCvoid*   (*alcGetProcAddressPtr)( ALCdevice *device,ALCubyte *funcName );
typedef ALCenum	   (*alcGetEnumValuePtr)( ALCdevice *device,ALCubyte *enumName );


extern alcGetStringPtr pfalcGetString;
extern alcGetIntegervPtr pfalcGetIntegerv;
extern alcOpenDevicePtr pfalcOpenDevice;
extern alcCloseDevicePtr pfalcCloseDevice;
extern alcCreateContextPtr pfalcCreateContext;
extern alcMakeContextCurrentPtr pfalcMakeContextCurrent;
extern alcProcessContextPtr pfalcProcessContext;
extern alcGetCurrentContextPtr pfalcGetCurrentContext;
extern alcGetContextsDevicePtr pfalcGetContextsDevice;
extern alcSuspendContextPtr pfalcSuspendContext;
extern alcDestroyContextPtr pfalcDestroyContext;
extern alcGetErrorPtr pfalcGetError;
extern alcIsExtensionPresentPtr pfalcIsExtensionPresent;
extern alcGetProcAddressPtr pfalcGetProcAddress;
extern alcGetEnumValuePtr pfalcGetEnumValue;

#ifdef __cplusplus
}
#endif

#endif //_CFM_ALC_H_
